package java.util;

public class GregorianCalendar extends Calendar {
   // $FF: renamed from: BC int
   public static final int field_0 = 0;
   // $FF: renamed from: AD int
   public static final int field_1 = 1;
   private static final long julianDayOffset = 2440588L;
   private static final int millisPerDay = 86400000;
   private static final int[] NUM_DAYS = new int[]{0, 31, 59, 90, 120, 151, 181, 212, 243, 273, 304, 334};
   private static final int[] LEAP_NUM_DAYS = new int[]{0, 31, 60, 91, 121, 152, 182, 213, 244, 274, 305, 335};
   private static final int[] MONTH_LENGTH = new int[]{31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};
   private static final int[] LEAP_MONTH_LENGTH = new int[]{31, 29, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};
   private long gregorianCutover;
   private static long JULIAN_ONSET = -62893584000000L;
   private static final long ONE_SECOND = 1000L;
   private static final long ONE_MINUTE = 60000L;
   private static final long ONE_HOUR = 3600000L;
   private static final long ONE_DAY = 86400000L;
   private static final long ONE_WEEK = 604800000L;
   static final long serialVersionUID = -8125100834729963327L;
   private static final int[] MinValues = new int[]{0, 1, 0, 0, 0, 1, 1, 1, -1, 0, 0, 0, 0, 0, 0, -43200000, 0};
   private static final int[] GreatestMinValues = new int[]{0, 1, 0, 0, 0, 1, 1, 1, -1, 0, 0, 0, 0, 0, 0, -43200000, 0};
   private static final int[] LeastMaxValues = new int[]{1, 5000000, 11, 53, 4, 28, 365, 7, 4, 1, 11, 23, 59, 59, 999, 43200000, 3600000};
   private static final int[] MaxValues = new int[]{1, 5000000, 11, 54, 6, 31, 366, 7, 6, 1, 12, 23, 59, 59, 999, 43200000, 3600000};

   private static final long millisToJulianDay(long var0) {
      return var0 >= 0L ? 2440588L + var0 / 86400000L : 2440588L + (var0 - 86400000L + 1L) / 86400000L;
   }

   private static final long julianDayToMillis(long var0) {
      return (var0 - 2440588L) * 86400000L;
   }

   public GregorianCalendar() {
      this(TimeZone.getDefault(), Locale.getDefault());
   }

   public GregorianCalendar(TimeZone var1) {
      this(var1, Locale.getDefault());
   }

   public GregorianCalendar(Locale var1) {
      this(TimeZone.getDefault(), var1);
   }

   public GregorianCalendar(TimeZone var1, Locale var2) {
      super(var1, var2);
      this.gregorianCutover = -12219292800000L;
      ((Calendar)this).setTimeInMillis(System.currentTimeMillis());
   }

   public GregorianCalendar(int var1, int var2, int var3) {
      super(TimeZone.getDefault(), Locale.getDefault());
      this.gregorianCutover = -12219292800000L;
      ((Calendar)this).set(0, 1);
      ((Calendar)this).set(1, var1);
      ((Calendar)this).set(2, var2);
      ((Calendar)this).set(5, var3);
   }

   public GregorianCalendar(int var1, int var2, int var3, int var4, int var5) {
      super(TimeZone.getDefault(), Locale.getDefault());
      this.gregorianCutover = -12219292800000L;
      ((Calendar)this).set(0, 1);
      ((Calendar)this).set(1, var1);
      ((Calendar)this).set(2, var2);
      ((Calendar)this).set(5, var3);
      ((Calendar)this).set(11, var4);
      ((Calendar)this).set(12, var5);
   }

   public GregorianCalendar(int var1, int var2, int var3, int var4, int var5, int var6) {
      super(TimeZone.getDefault(), Locale.getDefault());
      this.gregorianCutover = -12219292800000L;
      ((Calendar)this).set(0, 1);
      ((Calendar)this).set(1, var1);
      ((Calendar)this).set(2, var2);
      ((Calendar)this).set(5, var3);
      ((Calendar)this).set(11, var4);
      ((Calendar)this).set(12, var5);
      ((Calendar)this).set(13, var6);
   }

   public boolean equals(Object var1) {
      if (this == var1) {
         return true;
      } else if (!(var1 instanceof Calendar)) {
         return false;
      } else {
         Calendar var2 = (Calendar)var1;
         return ((Calendar)this).getTimeInMillis() == var2.getTimeInMillis() && ((Calendar)this).isLenient() == var2.isLenient() && ((Calendar)this).getFirstDayOfWeek() == var2.getFirstDayOfWeek() && ((Calendar)this).getMinimalDaysInFirstWeek() == var2.getMinimalDaysInFirstWeek() && ((Calendar)this).getTimeZone().equals(var2.getTimeZone());
      }
   }

   public boolean before(Object var1) {
      return var1 instanceof Calendar && ((Calendar)this).getTimeInMillis() < ((Calendar)var1).getTimeInMillis();
   }

   public boolean after(Object var1) {
      return var1 instanceof Calendar && ((Calendar)this).getTimeInMillis() > ((Calendar)var1).getTimeInMillis();
   }

   public void setGregorianChange(Date var1) {
      this.gregorianCutover = var1.getTime();
   }

   public final Date getGregorianChange() {
      return new Date(this.gregorianCutover);
   }

   private static final int julianDayToDayOfWeek(long var0) {
      int var2 = (int)((var0 + 1L) % 7L);
      return var2 + (var2 < 0 ? 8 : 1);
   }

   private final void timeToFields(long var1) {
      byte var8 = 1;
      long var19 = millisToJulianDay(var1);
      long var9;
      if (var1 >= this.gregorianCutover) {
         long var21 = (long)(((double)(var19 - 1867216L) - (double)0.25F) / (double)36524.25F);
         var9 = var19 + 1L + var21 - (long)((double)0.25F * (double)var21);
      } else {
         var9 = var19;
      }

      long var11 = var9 + 1524L;
      long var15 = (long)Math.floor((double)6680.0F + ((double)(var11 - 2439870L) - 122.10000000000001) / (double)365.25F);
      long var13 = (long)Math.floor((double)(365L * var15) + (double)0.25F * (double)var15);
      long var17 = (long)((double)(var11 - var13) / 30.6001);
      int var5 = (int)(var11 - var13 - (long)(30.6001 * (double)var17));
      int var4 = (int)var17 - 1;
      if (var4 > 12) {
         var4 -= 12;
      }

      int var3 = (int)(var15 - 4715L);
      if (var4 > 2) {
         --var3;
      }

      if (var3 <= 0) {
         var8 = 0;
         var3 = 1 - var3;
      }

      ((Calendar)this).internalSet(0, var8);
      ((Calendar)this).internalSet(1, var3);
      ((Calendar)this).internalSet(2, var4 - 1);
      ((Calendar)this).internalSet(5, var5);
      int var6 = julianDayToDayOfWeek(var19);
      ((Calendar)this).internalSet(7, var6);
      int var7;
      if (this.isLeapYear(var3)) {
         var7 = LEAP_NUM_DAYS[var4 - 1] + var5;
      } else {
         var7 = NUM_DAYS[var4 - 1] + var5;
      }

      ((Calendar)this).internalSet(6, var7);
      ((Calendar)this).internalSet(3, this.weekNumber(var7, var6));
      ((Calendar)this).internalSet(4, this.weekNumber(var5, var6));
      ((Calendar)this).internalSet(8, (var5 - 1) / 7 + 1);
   }

   private int weekNumber(int var1, int var2) {
      int var3 = (var2 - ((Calendar)this).getFirstDayOfWeek() - var1 + 1) % 7;
      if (var3 < 0) {
         var3 += 7;
      }

      int var4 = (var1 + var3 - 1) / 7;
      if (7 - var3 >= ((Calendar)this).getMinimalDaysInFirstWeek()) {
         ++var4;
      }

      return var4;
   }

   public boolean isLeapYear(int var1) {
      long var2 = (long)((double)(var1 - 1970) * 365.2422 * (double)8.64E7F);
      if (var2 < JULIAN_ONSET) {
         return false;
      } else if (var2 <= this.gregorianCutover) {
         return var1 % 4 == 0;
      } else {
         return var1 % 4 == 0 && (var1 % 100 != 0 || var1 % 400 == 0);
      }
   }

   protected void computeFields() {
      int var1 = ((Calendar)this).getTimeZone().getRawOffset();
      long var2 = super.time + (long)var1;
      this.timeToFields(var2);
      int var4 = ((Calendar)this).internalGet(0);
      int var5 = ((Calendar)this).internalGet(1);
      int var6 = ((Calendar)this).internalGet(2);
      int var7 = ((Calendar)this).internalGet(5);
      int var8 = ((Calendar)this).internalGet(7);
      long var9 = var2 / 86400000L;
      int var11 = (int)(var2 - var9 * 86400000L);
      if (var11 < 0) {
         var11 += 86400000;
      }

      int var12 = ((Calendar)this).getTimeZone().getOffset(var4, var5, var6, var7, var8, var11) - var1;
      var11 += var12;
      if (var11 >= 86400000) {
         var11 -= 86400000;
         var2 += (long)var12;
         this.timeToFields(var2);
      }

      ((Calendar)this).internalSet(14, var11 % 1000);
      var11 /= 1000;
      ((Calendar)this).internalSet(13, var11 % 60);
      var11 /= 60;
      ((Calendar)this).internalSet(12, var11 % 60);
      var11 /= 60;
      ((Calendar)this).internalSet(11, var11);
      ((Calendar)this).internalSet(9, var11 / 12);
      ((Calendar)this).internalSet(10, var11 % 12);
      ((Calendar)this).internalSet(15, var1);
      ((Calendar)this).internalSet(16, var12);

      for(int var13 = 0; var13 < 17; ++var13) {
         super.stamp[var13] = 1;
      }

      for(int var14 = 0; var14 < 17; ++var14) {
         super.isSet[var14] = true;
      }

   }

   boolean inDaylightTime() {
      if (!((Calendar)this).getTimeZone().useDaylightTime()) {
         return false;
      } else {
         ((Calendar)this).complete();
         return ((Calendar)this).internalGet(16) != 0;
      }
   }

   private final int monthLength(int var1, int var2) {
      return this.isLeapYear(var2) ? LEAP_MONTH_LENGTH[var1] : MONTH_LENGTH[var1];
   }

   private boolean validateFields() {
      for(int var1 = 0; var1 < 17; ++var1) {
         if (var1 != 5 && var1 != 6 && ((Calendar)this).isSet(var1) && !this.boundsCheck(((Calendar)this).internalGet(var1), var1)) {
            return false;
         }
      }

      if (((Calendar)this).isSet(5)) {
         int var3 = ((Calendar)this).internalGet(5);
         return var3 >= this.getMinimum(5) && var3 <= this.monthLength(((Calendar)this).internalGet(2), ((Calendar)this).internalGet(1));
      } else {
         if (((Calendar)this).isSet(6)) {
            int var2 = ((Calendar)this).internalGet(6);
            if (this.isLeapYear(((Calendar)this).internalGet(1))) {
               if (var2 < 1 || var2 > 366) {
                  return false;
               }
            } else if (var2 < 1 || var2 > 365) {
               return false;
            }
         }

         if (((Calendar)this).isSet(8) && ((Calendar)this).internalGet(8) == 0) {
            return false;
         } else {
            return true;
         }
      }
   }

   private boolean boundsCheck(int var1, int var2) {
      return var1 >= this.getMinimum(var2) && var1 <= this.getMaximum(var2);
   }

   private final int aggregateStamp(int var1, int var2) {
      return var1 != 0 && var2 != 0 ? Math.max(var1, var2) : 0;
   }

   protected void computeTime() {
      if (!((Calendar)this).isLenient() && !this.validateFields()) {
         throw new IllegalArgumentException();
      } else {
         long var1 = 0L;
         int var3;
         if (super.stamp[0] != 0) {
            var3 = ((Calendar)this).internalGet(0);
         } else {
            var3 = 1;
         }

         if (var3 >= 0 && var3 <= 1) {
            int var4 = super.stamp[1] != 0 ? ((Calendar)this).internalGet(1) : 1970;
            int var5 = 0;
            int var6 = 0;
            if (var3 == 0) {
               var4 = 1 - var4;
            }

            long var7 = 0L;
            int var9 = super.stamp[2];
            int var10 = super.stamp[5];
            int var11 = super.stamp[4];
            int var12 = super.stamp[8];
            int var13 = super.stamp[6];
            int var14 = super.stamp[3];
            int var15 = var9 > var10 ? var9 : var10;
            if (var11 > var15) {
               var15 = var11;
            }

            if (var12 > var15) {
               var15 = var12;
            }

            if (var13 > var15) {
               var15 = var13;
            }

            if (var14 > var15) {
               var15 = var14;
            }

            if (var15 != 0 && (var15 == var9 || var15 == var10 || var15 == var11 || var15 == var12)) {
               var5 = (var9 != 0 ? ((Calendar)this).internalGet(2) : 0) + 1;
               if (var5 < 1) {
                  var4 += var5 / 12 - 1;
                  var5 = 12 + var5 % 12;
               } else if (var5 > 12) {
                  var4 += var5 / 12;
                  var5 %= 12;
               }

               if (var5 > 2) {
                  ++var5;
               } else {
                  --var4;
                  var5 += 13;
               }

               var7 = (long)(Math.floor((double)365.25F * (double)var4) + Math.floor(30.6001 * (double)var5) + (double)1720995.0F);
               if (var15 != var10 && var15 != var9) {
                  long var33 = var7;
                  if (julianDayToMillis(var7) >= this.gregorianCutover) {
                     long var44 = (long)(0.01 * (double)var4);
                     var33 = var7 + 2L - var44 + (long)((double)0.25F * (double)var44);
                  }

                  int var45 = julianDayToDayOfWeek(var33 + 1L) - ((Calendar)this).getFirstDayOfWeek();
                  if (var45 < 0) {
                     var45 += 7;
                  }

                  var6 = 1 - var45 + (super.stamp[7] != 0 ? ((Calendar)this).internalGet(7) - ((Calendar)this).getFirstDayOfWeek() : 0);
                  if (var15 == var11) {
                     if (7 - var45 < ((Calendar)this).getMinimalDaysInFirstWeek()) {
                        var6 += 7;
                     }

                     var6 += 7 * (((Calendar)this).internalGet(4) - 1);
                  } else {
                     if (var6 < 1) {
                        var6 += 7;
                     }

                     int var19 = ((Calendar)this).internalGet(8);
                     if (var19 >= 0) {
                        var6 += 7 * (var19 - 1);
                     } else {
                        var6 += ((this.monthLength(((Calendar)this).internalGet(2), var4) - var6) / 7 + var19 + 1) * 7;
                     }
                  }
               } else {
                  var6 = var10 != 0 ? ((Calendar)this).internalGet(5) : 1;
               }

               var7 += (long)var6;
            } else {
               --var4;
               var7 = (long)(Math.floor((double)365.25F * (double)var4) + (double)428.0F + (double)1720995.0F);
               if (var15 == 0) {
                  ++var7;
               } else if (var15 == var13) {
                  var7 += (long)((Calendar)this).internalGet(6);
               } else if (var15 == var14) {
                  long var16 = var7;
                  if (julianDayToMillis(var7) >= this.gregorianCutover) {
                     long var18 = (long)(0.01 * (double)var4);
                     var16 = var7 + 2L - var18 + (long)((double)0.25F * (double)var18);
                  }

                  int var43 = julianDayToDayOfWeek(var16 + 1L) - ((Calendar)this).getFirstDayOfWeek();
                  if (var43 < 0) {
                     var43 += 7;
                  }

                  var6 = 1 - var43 + (super.stamp[7] != 0 ? ((Calendar)this).internalGet(7) - ((Calendar)this).getFirstDayOfWeek() : 0);
                  if (7 - var43 < ((Calendar)this).getMinimalDaysInFirstWeek()) {
                     var6 += 7;
                  }

                  var6 += 7 * (((Calendar)this).internalGet(3) - 1);
                  var7 += (long)var6;
               }
            }

            var1 = julianDayToMillis(var7);
            if (var1 >= this.gregorianCutover) {
               long var34 = (long)(0.01 * (double)var4);
               var7 += 2L - var34 + (long)((double)0.25F * (double)var34);
               var1 = julianDayToMillis(var7);
            }

            int var35 = 0;
            int var17 = super.stamp[11];
            int var46 = super.stamp[10];
            var15 = var46 > var17 ? var46 : var17;
            if (var15 != 0) {
               if (var15 == var17) {
                  var35 += ((Calendar)this).internalGet(11);
               } else {
                  var35 += ((Calendar)this).internalGet(10);
                  var35 += 12 * ((Calendar)this).internalGet(9);
               }
            }

            var35 *= 60;
            var35 += ((Calendar)this).internalGet(12);
            var35 *= 60;
            var35 += ((Calendar)this).internalGet(13);
            var35 *= 1000;
            var35 += ((Calendar)this).internalGet(14);
            TimeZone var47 = ((Calendar)this).getTimeZone();
            int var20 = super.stamp[15] >= 2 ? ((Calendar)this).internalGet(15) : var47.getRawOffset();
            var1 += (long)var35;
            int var21 = 0;
            if (super.stamp[15] >= 2) {
               var21 = ((Calendar)this).internalGet(16);
            } else {
               if (super.stamp[2] == 0 || super.stamp[5] == 0) {
                  this.timeToFields(var1);
               }

               var21 = var47.getOffset(var3, ((Calendar)this).internalGet(1), ((Calendar)this).internalGet(2), ((Calendar)this).internalGet(5), julianDayToDayOfWeek(var7), var35) - var20;
            }

            super.time = var1 - (long)var20 - (long)var21;
         } else {
            throw new IllegalArgumentException();
         }
      }
   }

   public synchronized int hashCode() {
      return ((Calendar)this).getFirstDayOfWeek() ^ ((Calendar)this).getMinimalDaysInFirstWeek();
   }

   public void add(int var1, int var2) {
      if (var2 != 0) {
         ((Calendar)this).complete();
         if (var1 == 1) {
            int var11 = ((Calendar)this).internalGet(1);
            if (((Calendar)this).internalGet(0) == 1) {
               var11 += var2;
               if (var11 > 0) {
                  ((Calendar)this).set(1, var11);
               } else {
                  ((Calendar)this).set(1, 1 - var11);
                  ((Calendar)this).set(0, 0);
               }
            } else {
               var11 -= var2;
               if (var11 > 0) {
                  ((Calendar)this).set(1, var11);
               } else {
                  ((Calendar)this).set(1, 1 - var11);
                  ((Calendar)this).set(0, 1);
               }
            }
         } else {
            if (var1 == 2) {
               int var3 = ((Calendar)this).internalGet(2) + var2;
               if (var3 >= 0) {
                  this.add(1, var3 / 12);
                  ((Calendar)this).set(2, var3 % 12);
               } else {
                  this.add(1, (var3 + 1) / 12 - 1);
                  var3 %= 12;
                  if (var3 < 0) {
                     var3 += 12;
                  }

                  ((Calendar)this).set(2, var3);
               }

               int var4 = this.monthLength(((Calendar)this).internalGet(2), ((Calendar)this).internalGet(1));
               int var5 = ((Calendar)this).internalGet(5);
               if (var5 > var4) {
                  ((Calendar)this).set(5, var4);
                  return;
               }
            } else {
               if (var1 == 0) {
                  int var10 = ((Calendar)this).internalGet(0) + var2;
                  if (var10 < 0) {
                     var10 = 0;
                  }

                  if (var10 > 1) {
                     var10 = 1;
                  }

                  ((Calendar)this).set(0, var10);
                  return;
               }

               long var8 = (long)((Calendar)this).internalGet(16);
               long var14 = (long)var2;
               switch (var1) {
                  case 3:
                  case 4:
                  case 8:
                     var14 *= 604800000L;
                     break;
                  case 5:
                  case 6:
                  case 7:
                     var14 *= 86400000L;
                     break;
                  case 9:
                     var14 *= 43200000L;
                     break;
                  case 10:
                  case 11:
                     var14 *= 3600000L;
                     break;
                  case 12:
                     var14 *= 60000L;
                     break;
                  case 13:
                     var14 *= 1000L;
                  case 14:
                     break;
                  case 15:
                  case 16:
                  default:
                     throw new IllegalArgumentException();
               }

               ((Calendar)this).setTimeInMillis(super.time + var14);
               var8 -= (long)((Calendar)this).internalGet(16);
               if (var14 != 0L) {
                  ((Calendar)this).setTimeInMillis(super.time + var8);
               }
            }

         }
      }
   }

   public void roll(int var1, boolean var2) {
      this.roll(var1, var2 ? 1 : -1);
   }

   void roll(int var1, int var2) {
      if (var2 != 0) {
         ((Calendar)this).complete();
         int var3 = this.getMinimum(var1);
         int var4 = this.getMaximum(var1);
         switch (var1) {
            case 2:
               int var20 = (((Calendar)this).internalGet(2) + var2) % 12;
               if (var20 < 0) {
                  var20 += 12;
               }

               ((Calendar)this).set(2, var20);
               int var25 = this.monthLength(var20, ((Calendar)this).internalGet(1));
               int var30 = ((Calendar)this).internalGet(5);
               if (var30 > var25) {
                  ((Calendar)this).set(5, var25);
               }

               return;
            case 3:
               int var19 = ((Calendar)this).internalGet(7) - ((Calendar)this).getFirstDayOfWeek();
               if (var19 < 0) {
                  var19 += 7;
               }

               int var24 = (var19 - ((Calendar)this).internalGet(6) + 1) % 7;
               if (var24 < 0) {
                  var24 += 7;
               }

               int var29;
               if (7 - var24 < ((Calendar)this).getMinimalDaysInFirstWeek()) {
                  var29 = 8 - var24;
               } else {
                  var29 = 1 - var24;
               }

               int var33 = this.isLeapYear(((Calendar)this).internalGet(1)) ? 366 : 365;
               int var36 = (var33 - ((Calendar)this).internalGet(6) + var19) % 7;
               int var37 = var33 + 7 - var36;
               int var14 = var37 - var29;
               int var40 = (((Calendar)this).internalGet(6) + var2 * 7 - var29) % var14;
               if (var40 < 0) {
                  var40 += var14;
               }

               var40 += var29;
               if (var40 < 1) {
                  var40 = 1;
               }

               if (var40 > var33) {
                  var40 = var33;
               }

               ((Calendar)this).set(6, var40);
               ((Calendar)this).clear(2);
               return;
            case 4:
               int var18 = ((Calendar)this).internalGet(7) - ((Calendar)this).getFirstDayOfWeek();
               if (var18 < 0) {
                  var18 += 7;
               }

               int var7 = (var18 - ((Calendar)this).internalGet(5) + 1) % 7;
               if (var7 < 0) {
                  var7 += 7;
               }

               int var28;
               if (7 - var7 < ((Calendar)this).getMinimalDaysInFirstWeek()) {
                  var28 = 8 - var7;
               } else {
                  var28 = 1 - var7;
               }

               int var32 = this.monthLength(((Calendar)this).internalGet(2), ((Calendar)this).internalGet(1));
               int var35 = (var32 - ((Calendar)this).internalGet(5) + var18) % 7;
               int var11 = var32 + 7 - var35;
               int var5 = var11 - var28;
               int var38 = (((Calendar)this).internalGet(5) + var2 * 7 - var28) % var5;
               if (var38 < 0) {
                  var38 += var5;
               }

               var38 += var28;
               if (var38 < 1) {
                  var38 = 1;
               }

               if (var38 > var32) {
                  var38 = var32;
               }

               ((Calendar)this).set(5, var38);
               return;
            case 5:
               var4 = this.monthLength(((Calendar)this).internalGet(2), ((Calendar)this).internalGet(1));
            case 0:
            case 1:
            case 9:
            case 10:
            case 11:
            case 12:
            case 13:
            case 14:
               int var15 = var4 - var3 + 1;
               int var21 = ((Calendar)this).internalGet(var1) + var2;
               var21 = (var21 - var3) % var15;
               if (var21 < 0) {
                  var21 += var15;
               }

               var21 += var3;
               ((Calendar)this).set(var1, var21);
               return;
            case 6:
               long var17 = (long)var2 * 86400000L;
               long var27 = super.time - (long)(((Calendar)this).internalGet(6) - 1) * 86400000L;
               int var34 = this.isLeapYear(((Calendar)this).internalGet(1)) ? 366 : 365;
               super.time = (super.time + var17 - var27) % ((long)var34 * 86400000L);
               if (super.time < 0L) {
                  super.time += (long)var34 * 86400000L;
               }

               ((Calendar)this).setTimeInMillis(super.time + var27);
               return;
            case 7:
               long var16 = (long)var2 * 86400000L;
               int var26 = ((Calendar)this).internalGet(7) - ((Calendar)this).getFirstDayOfWeek();
               if (var26 < 0) {
                  var26 += 7;
               }

               long var31 = super.time - (long)var26 * 86400000L;
               super.time = (super.time + var16 - var31) % 604800000L;
               if (super.time < 0L) {
                  super.time += 604800000L;
               }

               ((Calendar)this).setTimeInMillis(super.time + var31);
               return;
            case 8:
               long var6 = (long)var2 * 604800000L;
               int var8 = (((Calendar)this).internalGet(5) - 1) / 7;
               int var9 = (this.monthLength(((Calendar)this).internalGet(2), ((Calendar)this).internalGet(1)) - ((Calendar)this).internalGet(5)) / 7;
               long var10 = super.time - (long)var8 * 604800000L;
               long var12 = 604800000L * (long)(var8 + var9 + 1);
               super.time = (super.time + var6 - var10) % var12;
               if (super.time < 0L) {
                  super.time += var12;
               }

               ((Calendar)this).setTimeInMillis(super.time + var10);
               return;
            case 15:
            case 16:
            default:
               throw new IllegalArgumentException();
         }
      }
   }

   public int getMinimum(int var1) {
      return MinValues[var1];
   }

   public int getMaximum(int var1) {
      return MaxValues[var1];
   }

   public int getGreatestMinimum(int var1) {
      return GreatestMinValues[var1];
   }

   public int getLeastMaximum(int var1) {
      return LeastMaxValues[var1];
   }
}
